using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;
using System.Linq;
using bdAntifraude.dbcontext;
using System.Reflection;
using Microsoft.EntityFrameworkCore;
using System.ComponentModel.DataAnnotations;
using System.Linq.Expressions;
using SwaggerAntifraude.DTOs;
using System.Linq.Dynamic.Core;
using bdAntifraude.db;
using System.Runtime.CompilerServices;
using Serialize.Linq.Serializers;
using System.IO;
using Microsoft.EntityFrameworkCore.Metadata.Internal;
namespace SwaggerAntifraude.Controllers
{
    [ApiController]
    [Route("api/[controller]")]
    public class PUESTOSController : GenericoController<PUESTOS, int>
    {
        public PUESTOSController() : base()
        {
        }

        [Authorize(Policy = "LecturaPolicy")]
        [HttpPost("getActivos")] // Cambié a POST ya que estás usando [FromBody]
        public virtual async Task<IActionResult> getActivos([FromBody] ExpressionWrapper request)
        {
            try
            {
                using (var context = tsGestionAntifraude.NuevoContexto(SoloLectura: true, UseLazyLoadingProxies: false))
                {
                    // Crear el deserializador
                    var serializer = new ExpressionSerializer(new Serialize.Linq.Serializers.JsonSerializer());

                    // Deserializar la expresión
                    var deserializedExpression = serializer.DeserializeText(request.Expression) as Expression<Func<PUESTOS, bool>>;
                    if (deserializedExpression == null)
                    {
                        return BadRequest("La expresión deserializada es nula o incorrecta.");
                    }


                    var entities = await context.Set<PUESTOS>()
                    .Where(deserializedExpression)
                    .Include(v => v.IDRPTDESNavigation)
                        .ThenInclude(m => m.IDNIVEL_RPTNavigation)
                    .Include(v => v.IDRPTDESNavigation)
                        .ThenInclude(m => m.IDRPTNavigation)
                    .Include(v => v.IDRPTDESNavigation)
                        .ThenInclude(m => m.GRUPO1Navigation)
                    .Include(v => v.IDRPTDESNavigation)
                        .ThenInclude(m => m.CUERPO1Navigation)
                    .Include(v => v.IDRPTDESNavigation)
                        .ThenInclude(r => r.IDUNIDADADMINISTRATIVANavigation)
                    .Include(v => v.IDRPTNavigation)
                        .ThenInclude(x => x.IDSITUACIONNavigation)
                    .Include(v => v.IDOCUPACIONNavigation)
                    .Include(v => v.IDDOTACIONNavigation)
                     .Include(i => i.IDRPTDESNavigation)
                .ThenInclude(r => r.IDDEPARTAMENTONavigation)

                    .AsNoTracking()
                    .ToListAsync();
                    //var entities = await context.Set<PUESTOS>()
                    //    .Where(deserializedExpression)
                    //    .Include(v => v.IDRPTDESNavigation) // Incluyendo la navegación principal
                    //        .ThenInclude(m => m.IDNIVEL_RPTNavigation) // Incluye la navegación hacia IDNIVEL_RPT
                    //    .Include(v => v.IDRPTDESNavigation)
                    //        .ThenInclude(m => m.GRUPO1Navigation) // Incluye la navegación hacia GRUPO1
                    //    .Include(v => v.IDRPTDESNavigation)
                    //        .ThenInclude(m => m.CUERPO1Navigation) // Incluye la navegación hacia CUERPO1
                    //    .Include(v => v.IDRPTNavigation)
                    //        .ThenInclude(x => x.IDSITUACIONNavigation) // Incluye la navegación hacia IDSITUACION
                    //    .Include(v => v.IDOCUPACIONNavigation)
                    //    .AsNoTracking()
                    //    .ToListAsync();


                    // Verificar si el resultado es vacío
                    if (entities.Count == 0)
                    {
                        Console.WriteLine("La consulta no devolvió resultados.");
                    }

                    return Ok(entities);
                }
            }
            catch (Exception ex)
            {
                return StatusCode(500, $"Error interno del servidor: {ex.Message}");
            }
        }

        [Authorize(Policy = "LecturaPolicy")]
        [HttpGet("GetWithIncludes/{id}")]
        public async Task<IActionResult> GetWithIncludes(int id)
        {
            try
            {
                using (var context = tsGestionAntifraude.NuevoContexto(SoloLectura: true, UseLazyLoadingProxies: false))
                {
                    // Consulta con Includes necesarios
                    var entity = await context.PUESTOS
                    .Include(p => p.IDDOTACIONNavigation) // Carga Dotación
                    .Include(p => p.IDPERSONALNavigation) // Carga Persona asociada
                    .Include(p => p.IDOCUPACIONNavigation) // Carga Ocupación
                    .Include(p => p.TITULARNavigation) // Carga Titular                   
                    .AsNoTracking()
                    .Where(p => p.IDRPTDES == id).ToListAsync(); // Filtra por IDPUESTO

                    // Verifica si la entidad no se encontró
                    if (entity == null)
                        return NotFound($"El puesto con ID {id} no fue encontrado.");

                    // Devuelve la entidad con las relaciones cargadas
                    return Ok(entity);
                }
            }
            catch (Exception ex)
            {
                return StatusCode(500, $"Error interno del servidor: {ex.Message}");
            }
        }
        [Authorize(Policy = "LecturaPolicy")]
        [HttpGet("{id}")]
        public override IActionResult GetById(int id)
        {
            try
            {
                using (var context = tsGestionAntifraude.NuevoContexto(SoloLectura: true, UseLazyLoadingProxies: false))
                {
                    //var dbSet = context.Set<PUESTOS>();
                    var entity = context.PUESTOS
                     .Include(v => v.IDRPTDESNavigation)
                        .ThenInclude(m => m.IDNIVEL_RPTNavigation)
                    .Include(v => v.IDRPTDESNavigation)
                        .ThenInclude(m => m.IDRPTNavigation)
                    .Include(v => v.IDRPTDESNavigation)
                        .ThenInclude(m => m.GRUPO1Navigation)
                    .Include(v => v.IDRPTDESNavigation)
                        .ThenInclude(m => m.CUERPO1Navigation)
                    .Include(v => v.IDRPTDESNavigation)
                        .ThenInclude(r => r.IDUNIDADADMINISTRATIVANavigation)
                    .Include(v => v.IDRPTNavigation)
                        .ThenInclude(x => x.IDSITUACIONNavigation)
                    .Include(v => v.IDOCUPACIONNavigation)
                    .Include(v => v.IDDOTACIONNavigation)
                    .AsNoTracking()
                    .FirstOrDefault(v => v.IDPUESTO == id);

                    if (entity == null)
                        return NotFound();

                    return Ok(entity);
                }
            }
            catch (Exception ex)
            {
                return StatusCode(500, $"Error interno del servidor: {ex.Message}");
            }
        }
    }
}